"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
exports.default = issueCheck;
exports.isDeviceNodeProperties = isDeviceNodeProperties;
const IssueService_1 = require("../../common/services/IssueService");
const check_1 = require("../../common/services/IssueService/check");
const const_1 = require("../../const");
const globals_1 = require("../../globals");
function issueCheck(config) {
    const issues = [];
    const invalidIds = (0, check_1.getInvalidIds)(IssueService_1.IssueType.DeviceId, config, config.device);
    for (const id of invalidIds) {
        const message = globals_1.RED._(`home-assistant.service.issue.device_not_found`, {
            device_id: id,
        });
        issues.push({
            type: IssueService_1.IssueType.DeviceId,
            message,
            identity: id,
        });
    }
    return issues;
}
function isDeviceNodeProperties(node) {
    return node.type === const_1.NodeType.Device;
}
