"use strict";
var __importDefault = (this && this.__importDefault) || function (mod) {
    return (mod && mod.__esModule) ? mod : { "default": mod };
};
Object.defineProperty(exports, "__esModule", { value: true });
const ExposeAsMixin_1 = __importDefault(require("../../common/controllers/ExposeAsMixin"));
const OutputController_1 = __importDefault(require("../../common/controllers/OutputController"));
const ExposeAsController = (0, ExposeAsMixin_1.default)((OutputController_1.default));
class NumberOutputController extends ExposeAsController {
    async onValueChange(value, previousValue) {
        if (!this.isEnabled || isNaN(value))
            return;
        const message = {};
        await this.setCustomOutputs(this.node.config.outputProperties, message, {
            config: this.node.config,
            value,
            previousValue,
        });
        this.status.setSuccess(value.toString());
        this.node.send(message);
    }
}
exports.default = NumberOutputController;
