"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
exports.default = issueCheck;
exports.isTriggerStateProperties = isTriggerStateProperties;
const IssueService_1 = require("../../common/services/IssueService");
const check_1 = require("../../common/services/IssueService/check");
const const_1 = require("../../const");
const globals_1 = require("../../globals");
function issueCheck(config) {
    var _a;
    const issues = [];
    const invalidIds = (0, check_1.getInvalidIds)(IssueService_1.IssueType.StateId, config, (_a = config.entities) === null || _a === void 0 ? void 0 : _a.entity);
    for (const id of invalidIds) {
        const message = globals_1.RED._(`home-assistant.service.issue.entity_not_found`, {
            entity_id: id,
        });
        issues.push({
            type: IssueService_1.IssueType.StateId,
            message,
            identity: id,
        });
    }
    return issues;
}
function isTriggerStateProperties(node) {
    return node.type === const_1.NodeType.TriggerState;
}
